/*=========================================================
	
	inimgr.h
	
	INIt@C}l[WB
	
=========================================================*/
#ifndef INIMGR_H
#define INIMGR_H

#include <pspkernel.h>
#include <stdbool.h>

/*=========================================================
	萔/}N
=========================================================*/
#define INIMGR_ENTRY_LENGTH   255
#define INIMGR_SECTION_LENGTH 32

/*=========================================================
	IvV
=========================================================*/
#define INIMGR_CREATE ( FH_O_RDONLY )
#define INIMGR_SAVE ( FH_O_RDWR | FH_O_CREAT )

/*=========================================================
	^錾
=========================================================*/
typedef intptr_t InimgrUID;
typedef intptr_t InimgrContext;
typedef uint32_t InimgrVersion;

typedef enum {
	INIMGR_OP_LOAD,
	INIMGR_OP_SAVE
} InimgrOpMode;

typedef int ( *InimgrCallback )( InimgrContext, void* );

/*=========================================================
	֐
=========================================================*/
/*-----------------------------------------------
	inimgrNew
	
	VINI}l[W𐶐B
	
	@return: InimgrUID
		̊֐ŎgUIDB
-----------------------------------------------*/
InimgrUID inimgrNew( void );

/*-----------------------------------------------
	inimgrDestroy
	
	INI}l[W폜B
	
	@param: InimgrUID uid
		inimgrNew()œUIDB
	
	@return: int
		= 0: 
		< 0: G[
-----------------------------------------------*/
int inimgrDestroy( InimgrUID uid );

/*-----------------------------------------------
	inimgrMakeVersion
	
	inimgrLoad()inimgrSave()AinimgrMerge()Ŏgo[Wԍ𐶐B
	ŐInimgrVersiońAP == != < =< > >= ƂZqŔr\B
	
	
-----------------------------------------------*/
InimgrVersion inimgrMakeVersion( unsigned char major, unsigned char minor, unsigned char rev );

/*-----------------------------------------------
	inimgrRegisterCallback
	
	inimgrLoadSection()/inimgrSave()/inimgrMerge()ŌĂяoR[obN֐B
	ZNVɑʂ̃f[^ꍇȂǂɎgpAt@C璼ڃf[^ĂŃߖ񂷂B
	
	R[obNZNVłĂ key = value ̌`ȊOœǂݏ邱Ƃ͂łȂB
	
	inimgrLoadSection()ɁAR[obNݒ肳ꂽZNVǂݏoƂƁAR[obNB
	inimgrSave()/inimgrMerge()ł́AR[obNݒ肳ꂽZNVoƂƂɃR[obNB
	
	R[obNꂽ֐́AinimgrReadEntry()/inimgrWriteEntry()găf[^ǂݏo菑o肷B
	
	ΏۂƂȂZNV̎wɂ̓ChJ[h( ? * )gpłB
	}b`ZNVł́ASăR[obNB
	
	@param: InimgrUID uid
		inimgrNew()œUIDB
	
	@param: const char *wildcard
		R[obNZNVB
		ChJ[hgp\B
	
	@param: InimgrCallback cb
		R[obN֐B
	
	@param: void *arg
		R[obN֐ɓnB
		Zbgꂽl̂܂ܓnB
	
	@return: int
		= 0: 
		< 0: G[
-----------------------------------------------*/
int inimgrRegisterCallback( InimgrUID uid, const char *wildcard, InimgrCallback cb, void *arg );

/*-----------------------------------------------
	inimgrLoad
	
	INIt@C[h鏀sB
	̊֐INIt@CSɃ[h킯ł͂ȂB
	ɂeZNṼt@Cł̃ItZbg擾B
	
	ۂɃf[^gpɂ́AinimgrLoadSection()ŕKvȃZNVǂݏoȂ΂ȂB
	
	@param: InimgrUID uid
		inimgrNew()œUIDB
	
	@param: const char *path
		INIt@C̃pXB
	
	@param: const char *sig
		`FbNVOl`B
		vȂ΁ACG_ERROR_INI_SIGNATURE_MISMATCH ԂB
	
	@param: InimgrVersion version
		inimgrMakeVersion()̕ԂlB
		Lȃo[Ww肷B
		w肵o[WAINIt@C̃o[WÂ
		CG_ERROR_INI_VERSION_NOT_SUPPORTED ԂB
	
	@return int
		= 0: 
		< 0: G[
-----------------------------------------------*/
int inimgrLoad( InimgrUID uid, const char *path, const char *sig, InimgrVersion version );

/*-----------------------------------------------
	inimgrLoadSection
	
	w肵ZNV[hāAǂݏ\ȏԂɂB
	inimgrLoad()́APɃZNṼItZbgL^Ă邾Ȃ̂ŁA
	̊֐ŃGgǂݏoȂ inimgrGet* / inimgrSet* ͍sȂB
-----------------------------------------------*/
int inimgrLoadSection( InimgrUID uid, const char *name );

/*-----------------------------------------------
	inimgrLoadAllSections
	
	inimgrLoadSection()𑶍݂邷ׂẴZNVɑ΂čsB
-----------------------------------------------*/
int inimgrLoadAllSections( InimgrUID uid );

/*-----------------------------------------------
	inimgrAddSection
	
	VZNV쐬B
	inimgrSet*́A݂ȂZNV֒lZbg邱Ƃ͏oȂB
	IɃZNV͍쐬Ȃ߁Aō쐬KvB
	
	łɑ݂ĂZNV쐬悤Ƃꍇ͉ԂB
-----------------------------------------------*/
int inimgrAddSection( InimgrUID uid, const char *name );

/*-----------------------------------------------
	inimgrSave
	
	̃f[^INIt@CƂďoB
	w肵pXցÃf[^Pɏ㏑B
	ǂݏoȂZNV͋ɂȂĂ܂B
-----------------------------------------------*/
int inimgrSave( InimgrUID uid, const char *path, const char *sig, InimgrVersion version );

/*-----------------------------------------------
	inimgrMerge ()
	
	̃f[^ƁAINIt@C}[WB
	̃f[^D悳B
	
	}[Wɂ́Axꎞt@CɏoKv邽߁Aꎞt@C̃pXɕKvƂB
-----------------------------------------------*/
int inimgrMerge( InimgrUID uid, const char *path, const char *tempfile, const char *sig, InimgrVersion version );

/*-----------------------------------------------
	inimgrReadEntry
	
	GgǂݏoB
-----------------------------------------------*/
bool inimgrReadEntry( InimgrContext context, char **key, char **value );

/*-----------------------------------------------
	inimgrWriteEntry
	
	GgoB
-----------------------------------------------*/
bool inimgrWriteEntry( InimgrContext context, const char *key, const char *value );

/*-----------------------------------------------
	inimgrGetCurrentUID
	
	݂InimgrUIDԂB
-----------------------------------------------*/
InimgrUID inimgrGetCurrentUID( InimgrContext context );

/*-----------------------------------------------
	inimgrGetCurrentOpMode
	
	݂̃Iv[hԂB
-----------------------------------------------*/
InimgrOpMode inimgrGetCurrentOpMode( InimgrContext context );

int inimgrGetInt( InimgrUID uid, const char *name, const char *key, int *res );
int inimgrGetString( InimgrUID uid, const char *name, const char *key, char *res, size_t reslen );
int inimgrGetBool( InimgrUID uid, const char *name, const char *key, bool *res );
int inimgrSetInt( InimgrUID uid, const char *name, const char *key, int32_t integer );
int inimgrSetString( InimgrUID uid, const char *name, const char *key, const char *str );
int inimgrSetBool( InimgrUID uid, const char *name, const char *key, bool bl );


#endif
