/* dmemFree.c */

#include "dmem_types.h"

int dmemFree( DmemUID uid, void *ptr )
{
	struct dmem_root *root = (struct dmem_root *)uid;
	struct dmem_heap **heap;
	
	if( ! ptr || ! root->lastUse ) return CG_ERROR_OK;
	
	heap = (struct dmem_heap **)( (uintptr_t)ptr - sizeof( struct dmem_heap * ) );
	
	if( (*heap)->count == 1 ){
		/* q[vubNɎȂ΃q[vƉ */
		struct dmem_heap *avail_heap;
		
		if( *heap == root->heapList ){
			/* 폜Ώۃq[v擪̏ꍇ̓[g̃q[vGAXg̊JnʒuC */
			avail_heap = (*heap)->next;
			root->heapList = avail_heap;
		} else{
			/* 폜Ώۃq[v̑Õq[v擾 */
			for( avail_heap = root->heapList; avail_heap; avail_heap = avail_heap->next ){
				if( avail_heap->next == *heap ) break;
			}
			
			if( ! avail_heap ){
				/* 폜Ώۃq[ṽAhX́AnꂽDmemUID̊ǊO */
				return CG_ERROR_INVALID_ARGUMENT;
			}
			
			/* ăN */
			avail_heap->next = (*heap)->next;
		}
		
		/* ŌɎgpq[v폜Ώۃq[vwĂAǂł̂ŐĂq[vwB */
		if( root->lastUse == *heap ) root->lastUse = avail_heap;
		
		heapDestroy( (*heap)->uid );
	} else{
		int ret;
		/* q[vɊ蓖čς݃JEgZAq[vɕԋp */
		(*heap)->count--;
		ret = heapFree( (*heap)->uid, (void *)heap );
		
		if( ret != CG_ERROR_OK ) return ret;
	}
	
	return CG_ERROR_OK;
}
